#include <bits/stdc++.h>
#include "testlib.h"

#define pii pair<int, int>
#define mp make_pair
#define X first
#define Y second

using namespace std;
int N, M;
char cave[2005][2005];
bool toF[2005][2005];
vector<pii> dsu_S;
vector<pii> dsu_F[1000005];
int dx[4] = { 1, -1, 0, 0 };
int dy[4] = { 0, 0, 1, -1 };
queue<pii> q;

bool ok(int x, int y) {
    return (x >= 1 && x <= N && y >= 1 && y <= M);
}
pii getRandPos() {
    while (1) {
        int x = rnd.next(1, N);
        int y = rnd.next(1, M);
        if (cave[x][y] == '#' && !toF[x][y]) {
            return mp(x, y);
        }
    }
}
void setRandPortal(vector<pii> &v) {
    while (1) {
        int i = rnd.next(1, (int) v.size() - 1);
        if (cave[v[i].X][v[i].Y] == '.') {
            cave[v[i].X][v[i].Y] = 'X';
            return;
        }
    }
}
int main( int argc, char *argv[] ) {
	cin.tie(0); cin.sync_with_stdio(0);
	/*argc = 15;
	argv = new char*[argc + 1];
	char argv2[argc + 1][20];
	for (int i = 1; i < argc; ++i) {
	    cin >> argv2[i];
        argv[i] = argv2[i];
	}
	freopen("output.txt", "w", stdout);*/
	registerGen(argc, argv, 1);

	N = atoi(argv[1]);
	M = atoi(argv[2]);
	int cnt_F = atoi(argv[3]);
	int min_F = atoi(argv[4]);
	int max_F = atoi(argv[5]);
	int min_pF = atoi(argv[6]);
	int max_pF = atoi(argv[7]);

	int size_S = rnd.next(atoi(argv[8]), atoi(argv[9]));
	int cnt_pS = rnd.next(atoi(argv[10]), atoi(argv[11]));
	int unic_pS = atoi(argv[12]);

	int cnt_p = atoi(argv[13]);
	int sumsize_p = atoi(argv[14]);

	/* INIT */
	for (int i = 1; i <= N; ++i) {
        for (int j = 1; j <= M; ++j) {
            cave[i][j] = '#';
        }
	}

	/* F ZONES */
	for (int i = 1; i <= cnt_F; ++i) {
        pii F = getRandPos();
        cave[F.X][F.Y] = 'F';
        dsu_F[i].push_back(F);

        int size_F = rnd.next(min_F, max_F);
        q = queue<pii>();
        q.push(F);
        while (!q.empty() && dsu_F[i].size() < size_F) {
            int x = q.front().X;
            int y = q.front().Y;
            q.pop();
            for (int k = 0; k < 4; ++k) {
                int nx = x + dx[k];
                int ny = y + dy[k];
                if (ok(nx, ny) && !toF[nx][ny] && cave[nx][ny] == '#') {
                    cave[nx][ny] = '.';
                    dsu_F[i].push_back(mp(nx, ny));
                    q.push(mp(nx, ny));
                }
            }
        }
        int cnt_pF = rnd.next(min_pF, max_pF);
        for (int j = 1; j <= min((int) dsu_F[i].size() - 1, cnt_pF); ++j) {
            setRandPortal(dsu_F[i]);
        }
        for (int j = 0; j < (int) dsu_F[i].size(); ++j) {
            for (int k = 0; k < 4; ++k) {
                int nx = dsu_F[i][j].X + dx[k];
                int ny = dsu_F[i][j].Y + dy[k];
                if (ok(nx, ny)) {
                    toF[nx][ny] = true;
                }
            }
        }
	}

	/* S ZONE */
    pii S = getRandPos();
    cave[S.X][S.Y] = 'S';
    dsu_S.push_back(S);
    q = queue<pii>();
    q.push(S);
    while (!q.empty() && dsu_S.size() < size_S) {
        int x = q.front().X;
        int y = q.front().Y;
        q.pop();
        for (int k = 0; k < 4; ++k) {
            int nx = x + dx[k];
            int ny = y + dy[k];
            if (ok(nx, ny) && cave[nx][ny] == '#') {
                dsu_S.push_back(mp(nx, ny));
                if (toF[nx][ny] && cnt_pS) {
                    cave[nx][ny] = 'X';
                    --cnt_pS;
                } else if (!toF[nx][ny]) {
                    cave[nx][ny] = '.';
                    q.push(mp(nx, ny));
                }
            }
        }
    }
    if (unic_pS) {
        for (int j = 1; j <= min((int) dsu_S.size() - 1, max(1, cnt_pS)); ++j) {
            setRandPortal(dsu_S);
        }
    }
    for (int j = 0; j < (int) dsu_S.size(); ++j) {
        for (int k = 0; k < 4; ++k) {
            int nx = dsu_S[j].X + dx[k];
            int ny = dsu_S[j].Y + dy[k];
            if (ok(nx, ny)) {
                toF[nx][ny] = true;
            }
        }
    }

    /* FREE PORTALS ZONES */
    q = queue<pii>();
    for (int i = 1; i <= cnt_p; ++i) {
        pii p = getRandPos();
        cave[p.X][p.Y] = 'X';
        q.push(p);
    }
    while (!q.empty() && sumsize_p > 0) {
        int x = q.front().X;
        int y = q.front().Y;
        q.pop();
        for (int k = 0; k < 4; ++k) {
            int nx = x + dx[k];
            int ny = y + dy[k];
            if (ok(nx, ny) && cave[nx][ny] == '#') {
                --sumsize_p;
                if (!toF[nx][ny]) {
                    cave[nx][ny] = '.';
                    q.push(mp(nx, ny));
                }
            }
        }
    }

    /* PRINT CAVE */
	cout << N << " " << M << endl;
	for (int i = 1; i <= N; ++i) {
        for (int j = 1; j <= M; ++j) {
            cout << cave[i][j];
        }
        cout << endl;
	}
    return 0;
}
